Public Class MyNamespace
    'Private members
    Private strApplicationName As String = String.Empty
    Private blnSuppressMsgBox As Boolean = True

    'Public Events
    Public Event ApplicationCopyrightChanged(ByVal text As String)
    Public Event ScreenBoundsChanged(ByVal bounds As Rectangle)
    Public Event ScreenWorkingAreaChanged(ByVal bounds As Rectangle)

    Public Property ApplicationName() As String
        Get
            Return strApplicationName
        End Get
        Set(ByVal value As String)
            strApplicationName = value
        End Set
    End Property

    Public Property SuppressMsgBox() As Boolean
        Get
            Return blnSuppressMsgBox
        End Get
        Set(ByVal value As Boolean)
            blnSuppressMsgBox = value
        End Set
    End Property

    Private Sub btnApplicationCopyright_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnApplicationCopyright.Click

        RaiseEvent ApplicationCopyrightChanged( _
            My.Application.Info.Copyright)

        If Not blnSuppressMsgBox Then
            MessageBox.Show(My.Application.Info.Copyright, _
                strApplicationName)
        End If
    End Sub

    Private Sub btnScreenBounds_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles btnScreenBounds.Click

        RaiseEvent ScreenBoundsChanged(My.Computer.Screen.Bounds)

        If Not blnSuppressMsgBox Then
            MessageBox.Show(My.Computer.Screen.Bounds.ToString, _
                strApplicationName)
        End If
    End Sub

    Private Sub btnScreenWorkingArea_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles btnScreenWorkingArea.Click

        RaiseEvent ScreenWorkingAreaChanged(My.Computer.Screen.WorkingArea)

        If Not blnSuppressMsgBox Then
            MessageBox.Show(My.Computer.Screen.WorkingArea.ToString, _
                strApplicationName)
        End If
    End Sub

    Public Function TaskBarHeight() As Integer
        Return My.Computer.Screen.Bounds.Height - _
            My.Computer.Screen.WorkingArea.Height
    End Function

    Protected Overrides Sub InitLayout()
        'Are we in design mode?
        If DesignMode Then
            lblTime.Text = "Design Mode"
        Else
            Timer1.Enabled = True
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles Timer1.Tick

        'Display the time
        lblTime.Text = Now.ToLongTimeString
    End Sub
End Class
