Imports System.Windows.Forms

Public Class Login
    'Private members
    Private intAttemptCount As Integer = 0
    Private blnAllowClosing As Boolean = False
    Private intUserID As Integer

    'Public events
    Public Event LoginFailed(ByVal sender As Object, ByVal e As EventArgs)
    Public Event LoginSucceeded(ByVal sender As Object, _
                         ByVal e As LoginEventArgs)
    Public Event LoginCancelled(ByVal sender As Object, ByVal e As EventArgs)

    Public ReadOnly Property UserID() As Integer
        Get
            Return intUserID
        End Get
    End Property

    Private Sub Login_Activated(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles Me.Activated

        'Populate the user name text box
        txtUserName.Text = My.User.Name

        'Set focus to the password text box
        txtPassword.Focus()
    End Sub

    Private Sub Login_FormClosing(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.FormClosingEventArgs) _
        Handles Me.FormClosing

        'If we are not allowing the form to close...
        If Not blnAllowClosing Then
            'Set the Cancel flag to True
            e.Cancel = True
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles btnOK.Click

        'Was a user name entered?
        If txtUserName.Text.Trim.Length > 0 Then

            'Was the password correct?
            If txtPassword.Text = "secret" Then

                'Successful login, set the User ID
                intUserID = 27

                'Raise the LoginSucceeded event
                RaiseEvent LoginSucceeded(Me, New LoginEventArgs(intUserID))

                'Turn on the allow closing flag
                blnAllowClosing = True

            Else

                'Inform the user that the password was invalid
                MessageBox.Show("The password you entered was invalid.", _
                    "Login")

                'Increment the attempt count
                intAttemptCount += 1

                'Check the attempt count
                If intAttemptCount = 3 Then

                    'Raise the LoginFailed event
                    RaiseEvent LoginFailed(Me, New EventArgs)

                    'Set the Cancel dialog result
                    Me.DialogResult = Windows.Forms.DialogResult.Cancel

                    'Turn on the allow closing flag
                    blnAllowClosing = True

                End If

            End If

        Else
            'Inform the user that they must supply a user name
            MessageBox.Show("You must supply a User Name.", "Login")
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles btnCancel.Click

        'Raise the LoginCancelled event
        RaiseEvent LoginCancelled(Me, New EventArgs)

        'Turn on the allow closing flag
        blnAllowClosing = True
    End Sub
End Class